#include <stdio.h>

extern long random();
extern char *malloc();


int *
random_simulate(npat)
int npat;
{
    register unsigned *x1, *x2;
    register int pats, i, *diffs;

    x1 = (unsigned *) malloc(sizeof(unsigned) * nodes1);
    x2 = (unsigned *) malloc(sizeof(unsigned) * nodes2);
    diffs = (int *) malloc(sizeof(int) * (nin+nout+1));

    for(i = 0; i < nout; i++) {
	diffs[nin+i] = 0;
    }

    for(pats = npat-1; pats >= 0; pats--) {
	/* assign inputs */
	for(i = nin-1; i >= 0; i--) {
	    x2[input_map[i]] = x1[i] = (unsigned) random();
	}

	func1(x1);
	func2(x2);

	/* check outputs */
	for(i = nout-1; i >= 0; i--) {
	    diffs[nin+i] |= (x1[nin+i] ^ x2[nin+output_map[i]]);
	}
    }

    return diffs;
}


main(argc, argv)
char **argv;
{
    int *diffs;
    int i, npat, anydiff, verbose = 1;

    if (argc != 2) {
	(void) fprintf(stderr, "usage: %s npats\n", argv[0]);
	exit(2);
    }

    npat = atoi(argv[1]);
    diffs = random_simulate(npat);

    anydiff = 0;
    for(i = 0; i < nout; i++) {
	anydiff |= diffs[nin+i];
    }

    if (anydiff) {
	(void) printf("Networks are not equivalent\n");
	for(i = 0; i < nout; i++) {
	    if (diffs[nin+i] != 0) {
		(void) printf("outputs %s disagree\n", output_names[i]);
	    }
	}
	(void) printf("\n");
	exit(1);
    } else {
	if (verbose) {
	    (void) printf("After %d patterns networks seem equivalent\n", 
		32*npat);
	}
	exit(0);
    }
}
